[关闭]
@Yano 2019-01-13T08:00:49.000000Z 字数 4315 阅读 1637

LeetCode 975 Odd Even Jump

LeetCode


题目描述

You are given an integer array A. From some starting index, you can make a series of jumps. The (1st, 3rd, 5th, ...) jumps in the series are called odd numbered jumps, and the (2nd, 4th, 6th, ...) jumps in the series are called even numbered jumps.

You may from index i jump forward to index j (with i < j) in the following way:

Return the number of good starting indexes.

Example 1:

Input: [10,13,12,14,15]
Output: 2
Explanation: 
From starting index i = 0, we can jump to i = 2 (since A[2] is the smallest among A[1], A[2], A[3], A[4] that is greater or equal to A[0]), then we can't jump any more.
From starting index i = 1 and i = 2, we can jump to i = 3, then we can't jump any more.
From starting index i = 3, we can jump to i = 4, so we've reached the end.
From starting index i = 4, we've reached the end already.
In total, there are 2 different starting indexes (i = 3, i = 4) where we can reach the end with some number of jumps.

Example 2:

Input: [2,3,1,1,4]
Output: 3
Explanation: 
From starting index i = 0, we make jumps to i = 1, i = 2, i = 3:

During our 1st jump (odd numbered), we first jump to i = 1 because A[1] is the smallest value in (A[1], A[2], A[3], A[4]) that is greater than or equal to A[0].

During our 2nd jump (even numbered), we jump from i = 1 to i = 2 because A[2] is the largest value in (A[2], A[3], A[4]) that is less than or equal to A[1].  A[3] is also the largest value, but 2 is a smaller index, so we can only jump to i = 2 and not i = 3.

During our 3rd jump (odd numbered), we jump from i = 2 to i = 3 because A[3] is the smallest value in (A[3], A[4]) that is greater than or equal to A[2].

We can't jump from i = 3 to i = 4, so the starting index i = 0 is not good.

In a similar manner, we can deduce that:
From starting index i = 1, we jump to i = 4, so we reach the end.
From starting index i = 2, we jump to i = 3, and then we can't jump anymore.
From starting index i = 3, we jump to i = 4, so we reach the end.
From starting index i = 4, we are already at the end.
In total, there are 3 different starting indexes (i = 1, i = 3, i = 4) where we can reach the end with some number of jumps.

Example 3:

Input: [5,1,3,4,2]
Output: 3
Explanation: 
We can reach the end from starting indexes 1, 2, and 4.

Note:

1 <= A.length <= 20000
0 <= A[i] < 100000

代码

这是本周4道题目中最难的一道,看题目就知道有多长了……其实认真读题发现一点都不难,只要把题目的描述用代码表达出来即可,不需要复杂的算法。但是往往这样的题在写代码时会很费时间。

下面的代码写了40分钟,在比赛结束的最后一分钟AC了,结果没有算上成绩……心塞……

下面是暴力解法,并不是最优的解法。

  1. public int oddEvenJumps(int[] A) {
  2. int ans = 1;
  3. for (int i = 0; i < A.length; i++) {
  4. // 从每个索引分别开始
  5. int j = -1;
  6. int jump = 1;
  7. while (j != A.length - 1) {
  8. int tmp = 0;
  9. int tmpI = j == -1 ? i : j;
  10. // 奇数跳
  11. if (jump % 2 == 1) {
  12. // 找比A[i]大的最小的索引
  13. tmp = Integer.MAX_VALUE;
  14. int c = -1;
  15. for (int k = tmpI + 1; k < A.length; k++) {
  16. if (A[tmpI] <= A[k]) {
  17. if (tmp > A[k]) {
  18. j = k;
  19. c = k;
  20. tmp = A[k];
  21. }
  22. }
  23. }
  24. if (c == -1) {
  25. break;
  26. }
  27. } else {
  28. // 偶数跳
  29. tmp = Integer.MIN_VALUE;
  30. int c = -1;
  31. // A[j] <= A[i],A[j] 要最大,如果多个,取最小的j
  32. for (int k = tmpI + 1; k < A.length; k++) {
  33. if (A[tmpI] >= A[k]) {
  34. if (tmp < A[k]) {
  35. tmp = A[k];
  36. c = k;
  37. j = k;
  38. }
  39. }
  40. }
  41. if (c == -1) {
  42. break;
  43. }
  44. }
  45. jump++;
  46. if (j >= A.length - 1) {
  47. ans++;
  48. break;
  49. } else if (j == -1) {
  50. break;
  51. }
  52. }
  53. }
  54. return ans;
  55. }

分析上面的解法,最耗时的当然是对于每个起始的i,都要for循环一遍找到下一跳的索引j。

TreeMap + DP

以下是参考:https://leetcode.com/problems/odd-even-jump/solution/

Intuition

As in Approach 1, the problem reduces to solving this question: for some index i during an odd numbered jump, what index do we jump to (if any)?

Algorithm

We can use a TreeMap, which is an excellent structure for maintaining sorted data. Our map vals will map values v = A[i] to indices i.

Iterating from i = N-2 to i = 0, we have some value v = A[i] and we want to know what the next largest or next smallest value is. The TreeMap.lowerKey and TreeMap.higherKey functions do this for us.

With this in mind, the rest of the solution is straightforward: we use dynamic programming to maintain odd[i] and even[i]: whether the state of being at index i on an odd or even numbered jump is possible to reach.

  1. public int oddEvenJumps(int[] A) {
  2. int N = A.length;
  3. if (N <= 1) return N;
  4. boolean[] odd = new boolean[N];
  5. boolean[] even = new boolean[N];
  6. odd[N-1] = even[N-1] = true;
  7. TreeMap<Integer, Integer> vals = new TreeMap();
  8. vals.put(A[N-1], N-1);
  9. for (int i = N-2; i >= 0; --i) {
  10. int v = A[i];
  11. if (vals.containsKey(v)) {
  12. odd[i] = even[vals.get(v)];
  13. even[i] = odd[vals.get(v)];
  14. } else {
  15. Integer lower = vals.lowerKey(v);
  16. Integer higher = vals.higherKey(v);
  17. if (lower != null)
  18. even[i] = odd[vals.get(lower)];
  19. if (higher != null) {
  20. odd[i] = even[vals.get(higher)];
  21. }
  22. }
  23. vals.put(v, i);
  24. }
  25. int ans = 0;
  26. for (boolean b: odd)
  27. if (b) ans++;
  28. return ans;
  29. }
添加新批注
在作者公开此批注前,只有你和作者可见。
回复批注